-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

-- speedThreshold in m/s
local speedThreshold = 5.5
local spoiler = 0

local function onInit()
    electrics.values['spoiler'] = 0
end

local function reset()
    onInit()
end

local function updateGFX(dt)
	-- Raise spoiler when applying handbrake
	if electrics.values['parkingbrake'] > 0.01 then
		spoiler = 1
	-- Close spoiler when speed reaches 0 unless handbrake applied
	elseif electrics.values['wheelspeed'] < 1 then
		spoiler = 0
	-- Air Brake
	elseif electrics.values['brake'] > 0.5 then
       if electrics.values['wheelspeed'] > speedThreshold then
            spoiler = 1
		end
	-- Close spoiler when cornering to give better traction to the front wheels
	elseif electrics.values['steering_input'] > 0.3 then
		spoiler = 0.46
	elseif electrics.values['steering_input'] < -0.3 then
		spoiler = 0.46
	-- Varying spoiler movement
	elseif electrics.values['airspeed'] > 45 then
		spoiler = 0.46
	elseif electrics.values['wheelspeed'] > 28 then
		if electrics.values['wheelspeed'] < 45 then
			spoiler = 0.8
		end
    elseif electrics.values['wheelspeed'] > 14 then
		if electrics.values['wheelspeed'] < 28 then
			spoiler = 0.65
		end
	elseif electrics.values['wheelspeed'] > 1 then
		if electrics.values['wheelspeed'] < 14 then
			spoiler = 0.46
	end
    -- Do not remove or edit content below or vehicle wont work
	else
		spoiler = 0
    end
        
    --push value
    electrics.values['spoiler'] = spoiler
end

-- public interface
M.onInit      = onInit
M.reset     = reset
M.updateGFX = updateGFX

return M